﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace vcsharp_pwm_demo_v1._0
{
    public partial class Form1 : Form
    {
        public const int maxFreqOptionForVFxx = 8;      ///< Constant for maximun option to provide in demo for frequenct for vybrid
        public const int maxFreqOptionForiMX6x = 12;    ///< Constant for maximun option to provide in demo for frequenct for iMX6x
        public const int pwmOffsetFactor = 65536;       ///< rounding off 0 to 65536 to 0 to 100 offset constant   
        public const UInt32 baseFreqVF50 = 20000000;    ///< Maximum Base freq for Vf50 is 66MHz(66000000 Hz) we starts with 20 Mhz for this demo      
        public const UInt32 baseFreqVF61 = 20000000;    ///< Maximmun Base freq for Vf61 is 83.3 MHz(83300000 Hz) we starts with 20 Mhz for this demo 
        public const UInt32 baseFreqiMX6x = 20000000;   ///< Maximum Base freq for Vf50 is 66MHz(66000000 Hz)we starts with 20 Mhz for this demo 
                                                      

        public IntPtr pwmHandle_A = IntPtr.Zero;        ///< Handle to PWM 1(PWM_A)
        public IntPtr pwmHandle_B = IntPtr.Zero;        ///< Handle to PWM 2(PWM_B)
        public IntPtr pwmHandle_C = IntPtr.Zero;        ///< Handle to PWM 3(PWM_C)
        public IntPtr pwmHandle_D = IntPtr.Zero;        ///< Handle to PWM 4(PWM_D)
        public UInt32 pwmBaseFreqDemo = baseFreqVF50;   ///< Initial base frequency while configuring pwm
        public uint pwmFrequencyA = 0;                  ///< Varable to store freq for PWM 1(PWM_A)
        public uint pwmFrequencyB = 0;                  ///< Varable to store freq for PWM 2(PWM_B)
        public uint pwmFrequencyC = 0;                  ///< Varable to store freq for PWM 3(PWM_C)
        public uint pwmFrequencyD = 0;                  ///< Varable to store freq for PWM 4(PWM_D)
        public uint dutyCycleA = 0;                     ///< Variale to store duty cycle PWM1(PWM_A)
        public uint dutyCycleB = 0;                     ///< Variale to store duty cycle PWM2(PWM_B)
        public uint dutyCycleC = 0;                     ///< Variale to store duty cycle PWM3(PWM_C)
        public uint dutyCycleD = 0;                     ///< Variale to store duty cycle PWM4(PWM_D)

        public Form1()
        {
            InitializeComponent();
            checkSOCDemoRunning();                                          ///< Check for module running and enter appropriate frequency selection option
            intiAllPWM();                                                   ///< Init PWM and open library for PWM
        }
        /// <summary>
        /// Initialize all and provide handle
        /// </summary>
        private void intiAllPWM()
        {
            pwmHandle_A = pwm.Pwm_Init("PWM1");                     ///< Init PWM1 handle
            if (pwmHandle_A == IntPtr.Zero)
            {
                MessageBox.Show("Unable to init PWM1");
            }
            pwm.Pwm_SetConfigInt(pwmHandle_A, "BaseFreq", pwmBaseFreqDemo, TdxCommon.ParamStorageType.StoreVolatile);
            pwm.Pwm_Open(pwmHandle_A);                              ///< Open PWM library
            pwmHandle_B = pwm.Pwm_Init("PWM2");                     ///< Init PWM2 handle
            if (pwmHandle_B == IntPtr.Zero)
            {
                MessageBox.Show("Unable to init PWM2");
            }
            pwm.Pwm_SetConfigInt(pwmHandle_B, "BaseFreq", pwmBaseFreqDemo, TdxCommon.ParamStorageType.StoreVolatile);
            pwm.Pwm_Open(pwmHandle_B);                              ///< Open PWM library
            pwmHandle_C = pwm.Pwm_Init("PWM3");                     ///< Init PWM3 handle
            if (pwmHandle_C == IntPtr.Zero)
            {
                MessageBox.Show("Unable to init PWM3");
            }
            pwm.Pwm_SetConfigInt(pwmHandle_C, "BaseFreq", pwmBaseFreqDemo, TdxCommon.ParamStorageType.StoreVolatile);
            pwm.Pwm_Open(pwmHandle_C);                              ///< Open PWM library
            pwmHandle_D = pwm.Pwm_Init("PWM4");                     ///< Init PWM4 handle
            if (pwmHandle_D == IntPtr.Zero)
            {
                MessageBox.Show("Unable to init PWM4");
            }
            pwm.Pwm_SetConfigInt(pwmHandle_D, "BaseFreq", pwmBaseFreqDemo, TdxCommon.ParamStorageType.StoreVolatile);
            pwm.Pwm_Open(pwmHandle_D);                              ///< Open PWM library
        }
        /// <summary>
        /// Check for Particular module and set combobox with appropriate frequency for particular module
        /// </summary>
        private void checkSOCDemoRunning()
        {
            long frequencyWithoutPeriod = 0;
            if (CoProc.eFormFactor.FormFactor_Colibri == CoProc.Cop_GetFormFactor())            ///< Get form factor Apalis or Colibri and check for colibri module
            {
                if (CoProc.eSocFamily.SocFamily_Vybrid == CoProc.Cop_GetSocFamily())            ///< Get SOC family like Txx, VFxx, iMX6xx, PXAxx and check for vybrid module
                {
                    if (CoProc.eSoc.Soc_VF50 == CoProc.Cop_GetSoc())                            ///< Get SOC used on Colibri module and check for Colibri Vf50 module
                    {
                        for (int counter = maxFreqOptionForVFxx; counter > -1; counter--)
                        {
                            frequencyWithoutPeriod = baseFreqVF50 / (1 << counter);             ///< Adding combobox with some predefined frequency to be selectable by user
                            cmbPWM1.Items.Add(frequencyWithoutPeriod);
                            cmbPWM2.Items.Add(frequencyWithoutPeriod);
                            cmbPWM3.Items.Add(frequencyWithoutPeriod);
                            cmbPWM4.Items.Add(frequencyWithoutPeriod);
                        }
                        lblInfo.Text = "Colibri VF50\nPWM signal (resolution = 1/baseFreq).\nBase frequencies: 66.0 MHz, where n is 1,2,4,8,16,32,64 or 128\n\nPWM_A(PWM1)=SODIMM 59\nPWM_B(PWM2)=SODIMM 28\nPWM_C(PWM3)=SODIMM 30\nPWM_D(PWM4)=SODIMM 67";
                    }
                    else if (CoProc.eSoc.Soc_VF61 == CoProc.Cop_GetSoc())                       ///< Get SOC used on Colibri module and check for colibri VF61 module
                    {
                        for (int counter = maxFreqOptionForVFxx; counter > -1; counter--)
                        {
                            frequencyWithoutPeriod = baseFreqVF61 / (1 << counter);
                            cmbPWM1.Items.Add(frequencyWithoutPeriod);
                            cmbPWM2.Items.Add(frequencyWithoutPeriod);
                            cmbPWM3.Items.Add(frequencyWithoutPeriod);
                            cmbPWM4.Items.Add(frequencyWithoutPeriod);
                        }
                        lblInfo.Text = "Colibri VF61\nPWM signal (resolution = 1/baseFreq).\nBase frequencies: 83.3 MHz, where n is 1,2,4,8,16,32,64 or 128\n\nPWM_A(PWM1)=SODIMM 59\nPWM_B(PWM2)=SODIMM 28\nPWM_C(PWM3)=SODIMM 30\nPWM_D(PWM4)=SODIMM 67";
                    }
                }
                else if (CoProc.eSocFamily.SocFamily_Imx6 == CoProc.Cop_GetSocFamily())             ///< Get SOC family like Txx, VFxx, iMX6xx, PXAxx and check for iMX6 module
                {
                    for (int counter = maxFreqOptionForiMX6x; counter > -1; counter--)
                    {
                        frequencyWithoutPeriod = baseFreqiMX6x / (1 << counter);
                        cmbPWM1.Items.Add(frequencyWithoutPeriod);
                        cmbPWM2.Items.Add(frequencyWithoutPeriod);
                        cmbPWM3.Items.Add(frequencyWithoutPeriod);
                        cmbPWM4.Items.Add(frequencyWithoutPeriod);
                    }
                    lblPWM1.Text = "PWM_B";
                    lblPWM2.Text = "PWM_D";
                    lblPWM3.Text = "PWM_A";
                    lblPWM4.Text = "PWM_C";
                    if (CoProc.eSoc.Soc_IMX6S == CoProc.Cop_GetSoc())                               ///< Get SOC used on Colibri module and check for Colibri iMX6S module
                    {
                        lblInfo.Text = "Colibri iMX6S\nPWM signal (resolution = 1/baseFreq).\nBase frequencies: 66.0 MHz, where n is 1 to 4096\n\nPWM_B(PWM1)=SODIMM 28\nPWM_D(PWM2)=SODIMM 67\nPWM_A(PWM3)=SODIMM 59\nPWM_C(PWM4)=SODIMM 30";
                    }
                    else if (CoProc.eSoc.Soc_IMX6DL == CoProc.Cop_GetSoc())                         ///< Get SOC used on Colibri module and check for Colibri iMX6Dl module
                    {
                        lblInfo.Text = "Colibri iMX6DL\nPWM signal (resolution = 1/baseFreq).\nBase frequencies: 66.0 MHz, where n is 1 to 4096\n\nPWM_B(PWM1)=SODIMM 28\nPWM_D(PWM2)=SODIMM 67\nPWM_A(PWM3)=SODIMM 59\nPWM_C(PWM4)=SODIMM 30";
                    }
                    else if (CoProc.eSoc.Soc_IMX6D == CoProc.Cop_GetSoc())                          ///< Get SOC used on Colibri module and check for Colibri iMX6D module
                    {
                        lblInfo.Text = "Colibri iMX6D\nPWM signal (resolution = 1/baseFreq).\nBase frequencies: 66.0 MHz, where n is 1 to 4096\n\nPWM_B(PWM1)=SODIMM 28\nPWM_D(PWM2)=SODIMM 67\nPWM_A(PWM3)=SODIMM 59\nPWM_C(PWM4)=SODIMM 30";
                    }
                }
                else if (CoProc.eSocFamily.SocFamily_PXA == CoProc.Cop_GetSocFamily())              ///< Get SOC family like Txx, VFxx, iMX6xx, PXAxx and check for PXAxxx module
                {
                    ///< This demo will not run on tegra 
                    MessageBox.Show("Wrong version of Demo for this Module");
                    this.Close();
                }
                else if (CoProc.eSocFamily.SocFamily_Tegra == CoProc.Cop_GetSocFamily())            ///< Get SOC family like Txx, VFxx, iMX6xx, PXAxx and check for Tegra module
                {
                    ///< This demo will not run on PXA
                    MessageBox.Show("Wrong version of Demo for this Module");
                    this.Close();
                }
            }
            else if (CoProc.eFormFactor.FormFactor_Apalis == CoProc.Cop_GetFormFactor())            ///< Get form factor Apalis or Colibri and check for Apalis module
            {
                if (CoProc.eSocFamily.SocFamily_Imx6 == CoProc.Cop_GetSocFamily())                  ///< Get SOC family like Txx, VFxx, iMX6xx, PXAxx and check for iMX6x module
                {
                    if (CoProc.eSoc.Soc_IMX6DL == CoProc.Cop_GetSoc())                              ///< Get SOC used on Apalis module and check for Colibri iMX6DL module
                    {
                        lblInfo.Text = "Apalis iMX6DL\nPWM signal (resolution = 1/baseFreq).\nBase frequencies: 66.0 MHz, where n is 1 to 4096\n\nPWM_A(PWM1)=SODIMM 59\nPWM_B(PWM2)=SODIMM 28\nPWM_C(PWM3)=SODIMM 30\nPWM_D(PWM4)=SODIMM 67";
                    }
                    else if (CoProc.eSoc.Soc_IMX6Q == CoProc.Cop_GetSoc())                          ///< Get SOC used on Apalis module and check for Colibri iMX6Q module
                    {
                        lblInfo.Text = "Apalis iMX6Q\nPWM signal (resolution = 1/baseFreq).\nBase frequencies: 66.0 MHz, where n is 1 to 4096\n\nPWM_A(PWM1)=SODIMM 59\nPWM_B(PWM2)=SODIMM 28\nPWM_C(PWM3)=SODIMM 30\nPWM_D(PWM4)=SODIMM 67";
                    }
                }
            }
            cmbPWM1.SelectedIndex = 0;                                                              ///< Setting all combobox to index 0
            cmbPWM2.SelectedIndex = 0;
            cmbPWM3.SelectedIndex = 0;
            cmbPWM4.SelectedIndex = 0;
        }
        /// <summary>
        /// Set button for Setting PWM on PWM1 channel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetPWMA_Click(object sender, EventArgs e)
        {
            pwmFrequencyA = Convert.ToUInt32(cmbPWM1.Text);                                                         ///< Get Frequency from combobox
            pwm.Pwm_SetPwm(pwmHandle_A, pwmFrequencyA, (dutyCycleA * pwmOffsetFactor) / 100);                       ///< Set PWM4 with provided configuration

        }
        /// <summary>
        /// Set button for Setting PWM on PWM2 channel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetPWMB_Click(object sender, EventArgs e)
        {
            pwmFrequencyB = Convert.ToUInt32(cmbPWM2.Text);                                                         ///< Get Frequency from combobox
            pwm.Pwm_SetPwm(pwmHandle_B, pwmFrequencyB, (dutyCycleB * pwmOffsetFactor) / 100);                       ///< Set PWM4 with provided configuration
        }
        /// <summary>
        /// Set button for Setting PWM on PWM3 channel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetPWMC_Click(object sender, EventArgs e)
        {
            pwmFrequencyC = Convert.ToUInt32(cmbPWM3.Text);                                                         ///< Get Frequency from combobox
            pwm.Pwm_SetPwm(pwmHandle_C, pwmFrequencyC, (dutyCycleC * pwmOffsetFactor) / 100);                       ///< Set PWM4 with provided configuration
        }
        /// <summary>
        /// Set button for Setting PWM on PWM4 channel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetPWMD_Click(object sender, EventArgs e)
        {
            pwmFrequencyD = Convert.ToUInt32(cmbPWM4.Text);                                                         ///< Get Frequency from combobox
            pwm.Pwm_SetPwm(pwmHandle_D, pwmFrequencyD, (dutyCycleD * pwmOffsetFactor) / 100);                       ///< Set PWM4 with provided configuration
        }
        /// <summary>
        /// Get duty for PWM1 from slider and update on GUI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dutyPWMA_ValueChanged(object sender, EventArgs e)
        {
            dutyCycleA = (uint)dutyPWMA.Value;
            lblDutyCycle1.Text = dutyCycleA.ToString(); ;                                ///< Display the Duty-cycle Selected For PWM_A
        }
        /// <summary>
        /// Get duty for PWM2 from slider and update on GUI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dutyPWMB_ValueChanged(object sender, EventArgs e)
        {
            dutyCycleB = (uint)dutyPWMB.Value;
            lblDutyCycle2.Text = dutyCycleB.ToString();                                  ///< Display the Duty-cycle Selected For PWM_B
        }
        /// <summary>
        /// Get duty for PWM3 from slider and update on GUI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dutyPWMC_ValueChanged(object sender, EventArgs e)
        {
            dutyCycleC = (uint)dutyPWMC.Value;
            lblDutyCycle3.Text = dutyCycleC.ToString(); ;                                 ///< Display the Duty-cycle Selected For PWM_C
        }
        /// <summary>
        /// Get duty for PWM4 from slider and update on GUI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dutyPWMD_ValueChanged(object sender, EventArgs e)
        {
            dutyCycleD = (uint)dutyPWMD.Value;
            lblDutyCycle4.Text = dutyCycleD.ToString(); ;                                  ///< Display the Duty-cycle Selected For PWM_D
        }
        /// <summary>
        /// Closing event of Form
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            ///< workaround deinit PWM1 and PWM2 will deint both FTM 0, 1 controller which are also used by PWM3 PWM4 respectively
            if (pwmHandle_A != IntPtr.Zero)
            {
                pwm.Pwm_Close(pwmHandle_A);                                             ///< Close PWM library
                pwm.Pwm_Deinit(pwmHandle_A);                                            ///< DeInit PWM handle
            }
            if (pwmHandle_B != IntPtr.Zero)
            {
                pwm.Pwm_Close(pwmHandle_B);                                             ///< Close PWM library
                pwm.Pwm_Deinit(pwmHandle_B);                                            ///< DeInit PWM handle
            }
        }
    }
}